# SPDX-License-Identifier: GPL-2.0-only OR BSD-2-Clause
%YAML 1.2
---
$id: http://devicetree.org/schemas/media/samsung,exynos5250-gsc.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Samsung Exynos SoC G-Scaler

maintainers:
  - Inki Dae <inki.dae@samsung.com>
  - Krzysztof Kozlowski <krzk@kernel.org>
  - Seung-Woo Kim <sw0312.kim@samsung.com>

description:
  G-Scaler is used for scaling and color space conversion on Samsung Exynos
  SoCs.

  Each G-Scaler node should have a numbered alias in the aliases node, in the
  form of gscN, N = 0...3.

properties:
  compatible:
    oneOf:
      - items:
          - enum:
              - samsung,exynos5250-gsc
              - samsung,exynos5420-gsc
          - const: samsung,exynos5-gsc
      - enum:
          - samsung,exynos5433-gsc
      - const: samsung,exynos5-gsc
        deprecated: True

  clocks:
    minItems: 1
    maxItems: 5

  clock-names:
    minItems: 1
    maxItems: 5

  interrupts:
    maxItems: 1

  iommus:
    maxItems: 1

  power-domains:
    maxItems: 1

  reg:
    maxItems: 1

  samsung,sysreg:
    $ref: /schemas/types.yaml#/definitions/phandle
    description:
      Syscon used to control the system registers to set writeback input and destination.

required:
  - compatible
  - clocks
  - clock-names
  - interrupts
  - reg

allOf:
  - if:
      properties:
        compatible:
          contains:
            enum:
              - samsung,exynos5-gsc
              - samsung,exynos5250-gsc
              - samsung,exynos5420-gsc
    then:
      properties:
        clocks:
          maxItems: 1
        clock-names:
          items:
            - const: gscl
    else:
      properties:
        clocks:
          minItems: 5
        clock-names:
          items:
            - const: pclk
            - const: aclk
            - const: aclk_xiu
            - const: aclk_gsclbend
            - const: gsd

additionalProperties: false

examples:
  - |
    #include <dt-bindings/clock/exynos5250.h>
    #include <dt-bindings/interrupt-controller/arm-gic.h>

    video-scaler@13e00000 {
        compatible = "samsung,exynos5250-gsc", "samsung,exynos5-gsc";
        reg = <0x13e00000 0x1000>;
        interrupts = <GIC_SPI 85 IRQ_TYPE_LEVEL_HIGH>;
        power-domains = <&pd_gsc>;
        clocks = <&clock CLK_GSCL0>;
        clock-names = "gscl";
        iommus = <&sysmmu_gsc0>;
    };
